package com.realnet.basic.Controllers;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import com.fasterxml.jackson.core.JsonProcessingException;
import org.springframework.web.bind.annotation.CrossOrigin;
import com.fasterxml.jackson.databind.JsonMappingException;
import com.realnet.config.EmailService;
import com.realnet.users.entity1.AppUser;
import com.realnet.users.service1.AppUserServiceImpl;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.data.domain.*;
import com.realnet.fnd.response.EntityResponse;
import org.springframework.http.*;
import org.springframework.beans.factory.annotation.*;
import com.realnet.basic.Entity.Projects;
import com.realnet.basic.Services.ProjectsService ;










@RequestMapping(value = "/Projects")
 @CrossOrigin("*") 
@RestController
public class ProjectsController {
	@Autowired
	private ProjectsService Service;

@Value("${projectPath}")
	private String projectPath;
 










	@PostMapping("/Projects")
		  public Projects Savedata(@RequestBody Projects data) {
		Projects save = Service.Savedata(data)	;









		System.out.println("data saved..." + save);

 return save;
	  }
@PutMapping("/Projects/{id}")
	public  Projects update(@RequestBody Projects data,@PathVariable Integer id ) {
		Projects update = Service.update(data,id);
		System.out.println("data update..." + update);
		return update;
	}	 
//	get all with pagination
	@GetMapping("/Projects/getall/page")
	public Page<Projects> getall(@RequestParam(value = "page", required = false) Integer page,
			@RequestParam(value = "size", required = false) Integer size) {
		Pageable paging = PageRequest.of(page, size);
		Page<Projects> get = Service.getAllWithPagination(paging);

		return get;

	}	
	@GetMapping("/Projects")
	public List<Projects> getdetails() {
		 List<Projects> get = Service.getdetails();		
		return get;
}
// get all without authentication 

	@GetMapping("/token/Projects")
	public List<Projects> getallwioutsec() {
		 List<Projects> get = Service.getdetails();		
		return get;
}
@GetMapping("/Projects/{id}")
	public  Projects  getdetailsbyId(@PathVariable Integer id ) {
		Projects  get = Service.getdetailsbyId(id);
		return get;
	}
@DeleteMapping("/Projects/{id}")
	public  ResponseEntity<?> delete_by_id(@PathVariable Integer id ) {
	Service.delete_by_id(id);
			return new ResponseEntity<>(new EntityResponse("Deleted"), HttpStatus.OK);
	
	}











}